<?

/* Function to reform her dates into something PHP can work with */
function FixDate($sCrappyNatalieDeeDate) {

	$aryDate = explode("-", $sCrappyNatalieDeeDate);
	
	if ( strlen($aryDate[0]) == 1 ) {
		$aryDate[0] = "0".$aryDate[0];
	}
	if ( strlen($aryDate[1]) == 1 ) {
		$aryDate[1] = "0".$aryDate[1];
	}
	if ( strlen($aryDate[2]) == 2 ) {
		$aryDate[2] = "20".$aryDate[2];
	}
	
	$sFixedDate = $aryDate[0] . "/" . $aryDate[1] . "/" .$aryDate[2];
	
	return($sFixedDate);
}


/* Custom User Agent */
$s = 'http://www.glitch13.com/nat.rss.php'; // the address of your page
$e = 'glitch13@glitch13.com'; // your email address
$fp = fsockopen('www.nataliedee.com', 80);
fputs($fp, "GET /index.php HTTP/1.0\r\n".
	"Host: www.nataliedee.com\r\n".
	"User-Agent: ".$s."; ".$e."\r\n\r\n");

/* Skip past all the non-comic bs */
while ( trim($line) != "<!-- updates -->" ) {
	
	$line = @fgets($fp);
	if ( @feof($fp) || !$line ) {
		die("could't parse out comics!\n");
	}

}

$aryEntry = array();
$iCount = 0;
$bDone = false;
/* Here's where knowing regexps would come in handy  */
/* but since I don't, have a heaping helping of crap */

/* Grab some comics, biatch */
while ( !feof($fp) && !$bDone ) {
	
	$line = fgets($fp);/* Date	*/

	/* if the first line is nothing, then we're done */
	if ( trim($line) == "" ) {
		$bDone = true;
	}

	if ( !$bDone ) {
		$sDate = $line;
		$sDate = str_replace("<b> ", "", $sDate);
		$sDate = str_replace(" </b>: ", "", $sDate);
		$sDate = str_replace("\n", "", $sDate);
		$sDate = FixDate($sDate);
		
		$aryEntry[$iCount]['date'] = $sDate;
		$aryEntry[$iCount]['stamp'] = strtotime($sDate);

		$line = fgets($fp);/* Comic	*/
		
		$iStartURL = strpos( $line, "\"") + 1;
		$iEndURL   = strpos( $line, "\"", $iStartURL); 
		$sComic = "http://www.nataliedee.com/".substr( $line, $iStartURL, ($iEndURL - $iStartURL) );
		
		$aryEntry[$iCount]['link'] = $sComic;

		$iStartName = strpos( $line, ">") + 1;
		$iEndName   = strpos( $line, "<", $iStartName); 
		$sName = substr( $line, $iStartName, ($iEndName - $iStartName) );

		$aryEntry[$iCount]['title'] = "Comic: ".$sName;
		$aryEntry[$iCount]['description'] = $sName;
		
		$iCount++;

		$line = fgets($fp);/* Blank Line*/
		$line = fgets($fp);/* <br>	*/
	}
}

/* Done with the comics, skip to the news updates */
while ( trim($line) != "<font face=\"verdana, arial\" size=2>" ) {
	$line = @fgets($fp);
	if ( @feof($fp) || !$line ) {
		die("could't parse out news!\n");
	}
}

/* skip one more line */
$line = @fgets($fp);

/* Grab some news, biatch */
/* Unix sees it as all being on one line because it's using DOS line breaks */
$line = @fgets($fp);
$aryLines = explode( "<br><br>", $line );
$bDone = false;
foreach ( $aryLines as $line ) {

	if ( strpos( $line, "join the notifylist!" ) !== FALSE ) {
		$bDone = true;
	}
	if ( !$bDone ) {
		$line = strip_tags($line); 	// News Line 
		$line = str_replace("\n", "", $line); 
		$line = str_replace("\r", "", $line); 
		$iDateEnd = strpos($line, ".");
		$sDate = substr($line, 0, $iDateEnd);
		$sDate = FixDate($sDate);
		
		$aryEntry[$iCount]['date'] = $sDate;
		$aryEntry[$iCount]['stamp'] = strtotime($sDate);

		$sNews = substr($line, ($iDateEnd+1));
		$sNews = trim($sNews);
		$aryEntry[$iCount]['link'] = "http://www.nataliedee.com";
		$aryEntry[$iCount]['title'] = "News: ". substr($sDate,0,32) ;
		$aryEntry[$iCount]['description'] = $sNews;
		
		$iCount++;
	}
	

}

/* Bubble McSorty: order comics and news by date */
$bFinished = false;
while ( !$bFinished ) {
	
	$bDirty = false;
	
	for ( $i = 0; $i < (count($aryEntry)-1); $i++) {
		if ( $aryEntry[$i]['stamp'] < $aryEntry[$i+1]['stamp'] ) {
			$obBuffer = $aryEntry[$i];
			$aryEntry[$i] = $aryEntry[$i+1];
			$aryEntry[$i+1] = $obBuffer;
			$bDirty = true;
		}

	}
	
	if ( !$bDirty ) {
		$bFinished = true;
	}
}

/* Begin the output: */
header( "Content-Type: text/xml" ) ;
echo "<?xml version=\"1.0\"  encoding=\"iso-8859-1\"?>"
?>

<rss version="2.0">
<channel>
	<title>Natalie Dee</title>
	<link>http://www.nataliedee.com</link>
	<description>Drawings to Huff By</description>
	<image>
		<url>http://www.nataliedee.com/huffthesnake.gif</url>
		<title>Huff the Snake</title>
		<link>http://www.glitch13.com/</link>
		<width>368</width>
		<height>161</height>
	</image>            

<?
foreach ( $aryEntry as $key => $val ) {
	
	echo "\t\t<item>\n";
	echo "\t\t\t<date>".$val['date']."</date>\n";
	echo "\t\t\t<title>".$val['title']."</title>\n";
	echo "\t\t\t<link>".$val['link']."</link>\n";
	echo "\t\t\t<description>".$val['description']."</description>\n";
	echo "\t\t</item>\n";
		
}

/* Goodnight Gracie */
?>
	</channel>
</rss>
